from random import randint, seed, shuffle
from string import ascii_lowercase as abc
seed(47)

def save(fname, J, T, relabel=True, reorder=True):
    print(fname, J, T if len(T)<=10 else (T[:10], '...'))
    N = len(T)+1
    new_labels = list(range(N))
    if relabel: shuffle(new_labels)

    f = open(fname,'w')
    print( N, file=f )
    print( new_labels[J], file=f )
    if reorder: shuffle(T)
    for x,y in T:
        if reorder and randint(0,1): x,y = y,x
        print( new_labels[x], new_labels[y], file=f )
    f.close()

def logrand(lo, hi):
    while True:
        b = randint(1, 30)
        x = randint(2**(b-1), (2**b)-1)
        if lo <= x <= hi: return x

def cesta(N): return [ (x,x+1) for x in range(N-1) ]

def hviezda(N): return [ (0,x+1) for x in range(N-1) ]

def obmedzeny_strom(N, K):
    hrany = []
    for n in range(1, N):
        pn = randint( max(0,n-K), n-1 )
        hrany.append( (pn, n) )
    return hrany

def nahodny_strom(N):
    hrany = []
    farba = list(range(N))
    vo_farbe = [ [n] for n in range(N) ]
    while len(hrany) < N-1:
        x, y = randint(0,N-1), randint(0,N-1)
        fx, fy = farba[x], farba[y]
        if fx == fy: continue
        if len(vo_farbe[fy]) > len(vo_farbe[fx]): x, y, fx, fy = y, x, fy, fx
        hrany.append( (x, y) )
        for z in vo_farbe[fy]: farba[z] = fx
        vo_farbe[fx].extend( vo_farbe[fy] )
        vo_farbe[fy] = []
    return hrany

def almost(MAXN): return randint( int(0.9*MAXN), MAXN )

# \item V sade 1 (1 bod) platí $n\leq 6$, $j=0$ a Absurdistan je za radom očíslovaná cesta.

for N in range(1, 7): 
    save(f'01.{abc[N-1]}.in', 0, cesta(N), relabel=False, reorder=False)

# \item V sade 2 (1 bod) platí $n\leq 50$ a Absurdistan je za radom očíslovaná cesta.

for t in range(6):
    N = 50 if t==5 else randint(7, 49)
    J = N-1 if t==3 else randint(1, N-2)
    save(f'02.{abc[t]}.in', J, cesta(N), relabel=False, reorder=False)

# \item V sade 3 (1 bod) platí $n\leq 100\,000$ a Absurdistan je cesta.

for t in range(6):
    N = 100000 if t==0 else logrand(51, 99999)
    J = randint(0, N-1)
    save(f'03.{abc[t]}.in', J, cesta(N) )

# \item V sade 4 (1 bod) platí $n\leq 6$.
# \item V sade 5 (2 body) platí $n\leq 30$.
# \item V sade 6 (2 body) platí $n\leq 3\,000$.
# \item V sade 7 (2 body) platí $n\leq 100\,000$.
LIMITS = { 4: 6, 5: 30, 6: 3000, 7: 100000 }
for sada in [4, 5, 6, 7]:
    MAXN = LIMITS[sada]
    save(f'{sada:02d}.a.in', 0, hviezda(MAXN))
    save(f'{sada:02d}.b.in', MAXN//2, hviezda(MAXN))
    save(f'{sada:02d}.c.in', 0, obmedzeny_strom(almost(MAXN),2) )
    save(f'{sada:02d}.d.in', MAXN//2, obmedzeny_strom(almost(MAXN),3) )
    save(f'{sada:02d}.e.in', 0, obmedzeny_strom(almost(MAXN),4) )
    save(f'{sada:02d}.f.in', 0, obmedzeny_strom(almost(MAXN),12) )
    save(f'{sada:02d}.g.in', 0, nahodny_strom(almost(MAXN)) )
    save(f'{sada:02d}.h.in', 0, nahodny_strom(almost(MAXN)) )

